let moduleName = "arcane-ink";

export class DataBook{
    fileImg;
    filePath;
    buttonImg;
    rounded;
    userColors = {};
}

let dataBook = new DataBook();

export class BookOfMagicInk extends FormApplication {
    picturesContent = `
    <div class="pictures_controls">
    <div class="pictures_controls_data">
        <div>
            <input id="leftCheck" name="leftCheck" type="checkbox">
            <label>${game.i18n.localize("MI.pictureAndDesignMenu.leftCheck")}</label>
        </div>
        <div>
            <input id="onCircle" name="onCircle" type="checkbox">
            <label>${game.i18n.localize("MI.pictureAndDesignMenu.onCircle")}</label>
        </div>
        <div>
            <input id="rightCheck" name="rightCheck" type="checkbox">
            <label>${game.i18n.localize("MI.pictureAndDesignMenu.rightCheck")}</label>
        </div>
        <div class="scalePic">
            <div data="data"><label>${game.i18n.localize("MI.pictureAndDesignMenu.scale")}:</label></div>
            <div data="data">
                <select id="scale" name="scale">
                    <option value="">X1</option>
                    <option value="two">X2</option>
                    <option value="three">X3</option>
                </select>
            </div>
        </div>
        <div class="refImg">
            <figure class="right two">
                <img src=${(game.user.getFlag(moduleName, "picturePath") !== undefined) ? game.user.getFlag(moduleName, "picturePath") : "icons/vtt-512.png"} name="refImg" id="refImg">
            </figure>
        </div>
        <div class="picturesInputContainer"><input class="picturesInput" id="picturesInput" type="text" name="picturesInput" value=${(game.user.getFlag(moduleName, "picturePath") !== undefined) ? game.user.getFlag(moduleName, "picturePath") : "icons/vtt-512.png"}></div>
        <div data="data"><button id="addPictures" class="buttonAddPictures button">${game.i18n.localize("MI.pictureAndDesignMenu.InsertPicture")}</button></div>

        <div data="data"><button id="narrative" class="buttonNarrative button">${game.i18n.localize("MI.pictureAndDesignMenu.narrative")}</button></div>
        <div data="data"><button id="advice" class="buttonAdvice button"><p><img src=${(game.user.getFlag(moduleName, "picturePath") !== undefined) ? game.user.getFlag(moduleName, "picturePath") : "icons/vtt-512.png"} name="butImg" id="butImg"></p><p>${game.i18n.localize("MI.pictureAndDesignMenu.advice")}</p></button></div>
        <div data="data"><button id="notable" class="buttonNotable button">${game.i18n.localize("MI.pictureAndDesignMenu.notable")}</button></div>

    </div>
        
    </div>`

    referenseContentTabs = `
    <div class="referenseContentTabs">
        <b>
        <nav class="referenseTabs" data-group="referense-tabs">
        <div class="referenseTabsContainer">
            <div><a class="itemRef" data-tab="tab1">${game.i18n.localize("MI.referenseContent.ability")}</a></div>
            <div><a class="itemRef" data-tab="tab2">${game.i18n.localize("MI.referenseContent.skill")}</a></div>
            <div><a class="itemRef" data-tab="tab3">${game.i18n.localize("MI.referenseContent.condition")}</a></div>
            <div><a class="itemRef" data-tab="tab4">${game.i18n.localize("MI.referenseContent.creatureType")}</a></div>
            <div><a class="itemRef" data-tab="tab5">${game.i18n.localize("MI.referenseContent.typeDamage")}</a></div>
            <div><a class="itemRef" data-tab="tab6">${game.i18n.localize("MI.referenseContent.tool")}</a></div>
            <div><a class="itemRef" data-tab="tab7">${game.i18n.localize("MI.referenseContent.areaOfEffect")}</a></div>
            <div><a class="itemRef" data-tab="tab8">${game.i18n.localize("MI.referenseContent.component")}</a></div>
            <div><a class="itemRef" data-tab="tab9">${game.i18n.localize("MI.referenseContent.spellSchool")}</a></div>
        </div>
        </nav>
        </b>

        <br>
            
        <div class="contentRefInput">
            
            <div class=numberCheck><input id="numberCheck" name="numberCheck" type="checkbox"></div>
            <div class=numberCheck><label>${game.i18n.localize("MI.referenseContent.ModifierFromText")}</label></div>

            <div class=NullCheck><input id="NullCheck" type="checkbox"></div>
            <div class=NullCheck><label>${game.i18n.localize("MI.referenseContent.emptyValue")}</label></div>

            <div class=skillPassiveCheck><input id="skillPassiveCheck" type="checkbox"></div>
            <div class=skillPassiveCheck><label>${game.i18n.localize("MI.referenseContent.skillList.passiveCheck")}</label></div>
            
            <div class=damageFormula style="display: none;"><label>${game.i18n.localize("MI.referenseContent.damageFormula")}</label></div>
            <div class=damageFormula style="display: none;"><input id="damageFormula" type="text"></div>

            <div class=numberForMod><label>${game.i18n.localize("MI.referenseContent.Modifier")}</label></div>
            <div class=numberForMod><input id="numberForMod" type="number"></div>
        </div>
        
        <br>
        <section class="contentRef">
            <div class="tab" data-tab="tab1" data-group="referense-tabs">
            <div class=abilityContainer>
                <div><label>${game.i18n.localize("MI.referenseContent.abilityList.savingThrow")}:</label></div>
                <div><input id="abilityCheck" name="abilityCheck" type="checkbox"></div>
                
                
                <div><label for="ability">${game.i18n.localize("MI.referenseContent.ability")}:</label></div>
                <div>
                <select id="ability" name="ability">
                    <option value="strength">${game.i18n.localize("MI.referenseContent.abilityList.strength")}</option>
                    <option value="dexterity">${game.i18n.localize("MI.referenseContent.abilityList.dexterity")}</option>
                    <option value="constitution">${game.i18n.localize("MI.referenseContent.abilityList.constitution")}</option>
                    <option value="intelligence">${game.i18n.localize("MI.referenseContent.abilityList.intelligence")}</option>
                    <option value="wisdom">${game.i18n.localize("MI.referenseContent.abilityList.wisdom")}</option>
                    <option value="charisma">${game.i18n.localize("MI.referenseContent.abilityList.charisma")}</option>
                </select>
                </div>
                <div class="buttonAbilityContainer"><button id="buttonAbility" class="buttonAbility button">${game.i18n.localize("MI.referenseContent.abilityList.setAbility")}</button></div>
            </div>
            </div>
            <div class="tab" data-tab="tab2" data-group="referense-tabs">

            <div class=skillContainer>
                
                <div><label for="skill">${game.i18n.localize("MI.referenseContent.skill")}:</label></div>
                <div>
                <select id="skill" name="skill">
                    <option value="acrobatics">${game.i18n.localize("MI.referenseContent.skillList.acrobatics")}</option>
                    <option value="animalHandling">${game.i18n.localize("MI.referenseContent.skillList.animalHandling")}</option>
                    <option value="arcana">${game.i18n.localize("MI.referenseContent.skillList.arcana")}</option>
                    <option value="athletics">${game.i18n.localize("MI.referenseContent.skillList.athletics")}</option>
                    <option value="deception">${game.i18n.localize("MI.referenseContent.skillList.deception")}</option>
                    <option value="history">${game.i18n.localize("MI.referenseContent.skillList.history")}</option>
                    <option value="insight">${game.i18n.localize("MI.referenseContent.skillList.insight")}</option>
                    <option value="intimidation">${game.i18n.localize("MI.referenseContent.skillList.intimidation")}</option>
                    <option value="investigation">${game.i18n.localize("MI.referenseContent.skillList.investigation")}</option>
                    <option value="medicine">${game.i18n.localize("MI.referenseContent.skillList.medicine")}</option>
                    <option value="nature">${game.i18n.localize("MI.referenseContent.skillList.nature")}</option>
                    <option value="perception">${game.i18n.localize("MI.referenseContent.skillList.perception")}</option>
                    <option value="performance">${game.i18n.localize("MI.referenseContent.skillList.performance")}</option>
                    <option value="persuasion">${game.i18n.localize("MI.referenseContent.skillList.persuasion")}</option>
                    <option value="religion">${game.i18n.localize("MI.referenseContent.skillList.religion")}</option>
                    <option value="sleightOfHand">${game.i18n.localize("MI.referenseContent.skillList.sleightOfHand")}</option>
                    <option value="stealth">${game.i18n.localize("MI.referenseContent.skillList.stealth")}</option>
                    <option value="survival">${game.i18n.localize("MI.referenseContent.skillList.survival")}</option>
                </select>
                </div>
                <div class="buttonSkillContainer"><button id="buttonSkill" class="buttonSkill button">${game.i18n.localize("MI.referenseContent.skillList.setSkill")}</button></div>
            </div>
            </div>
            <div class="tab" data-tab="tab3" data-group="referense-tabs">
            <div class=conditionContainer>
                <div><label for="condition">${game.i18n.localize("MI.referenseContent.condition")}:</label></div>
                <div>
                <select id="condition" name="condition">
                    <option value="blinded">${game.i18n.localize("MI.referenseContent.conditionList.blinded")}</option>
                    <option value="charmed">${game.i18n.localize("MI.referenseContent.conditionList.charmed")}</option>
                    <option value="deafened">${game.i18n.localize("MI.referenseContent.conditionList.deafened")}</option>
                    <option value="exhaustion">${game.i18n.localize("MI.referenseContent.conditionList.exhaustion")}</option>
                    <option value="frightened">${game.i18n.localize("MI.referenseContent.conditionList.frightened")}</option>
                    <option value="grappled">${game.i18n.localize("MI.referenseContent.conditionList.grappled")}</option>
                    <option value="incapacitated">${game.i18n.localize("MI.referenseContent.conditionList.incapacitated")}</option>
                    <option value="invisible">${game.i18n.localize("MI.referenseContent.conditionList.invisible")}</option>
                    <option value="paralyzed">${game.i18n.localize("MI.referenseContent.conditionList.paralyzed")}</option>
                    <option value="petrified">${game.i18n.localize("MI.referenseContent.conditionList.petrified")}</option>
                    <option value="poisoned">${game.i18n.localize("MI.referenseContent.conditionList.poisoned")}</option>
                    <option value="prone">${game.i18n.localize("MI.referenseContent.conditionList.prone")}</option>
                    <option value="restrained">${game.i18n.localize("MI.referenseContent.conditionList.restrained")}</option>
                    <option value="stunned">${game.i18n.localize("MI.referenseContent.conditionList.stunned")}</option>
                    <option value="unconscious">${game.i18n.localize("MI.referenseContent.conditionList.unconscious")}</option>
                </select>
                </div>
                <div class="buttonConditionContainer"><button id="buttonCondition" class="buttonCondition button">${game.i18n.localize("MI.referenseContent.conditionList.setCondition")}</button></div>
            </div>
            </div>
            <div class="tab" data-tab="tab4" data-group="referense-tabs">
            <div class=creatureTypeContainer>
                <div><label for="creatureType">${game.i18n.localize("MI.referenseContent.creatureType")}:</label></div>
                <div>
                <select id="creatureType" name="creatureType">
                    <option value="aberration">${game.i18n.localize("MI.referenseContent.creatureTypeList.aberration")}</option>
                    <option value="beast">${game.i18n.localize("MI.referenseContent.creatureTypeList.beast")}</option>
                    <option value="celestial">${game.i18n.localize("MI.referenseContent.creatureTypeList.celestial")}</option>
                    <option value="construct">${game.i18n.localize("MI.referenseContent.creatureTypeList.construct")}</option>
                    <option value="dragon">${game.i18n.localize("MI.referenseContent.creatureTypeList.dragon")}</option>
                    <option value="elemental">${game.i18n.localize("MI.referenseContent.creatureTypeList.elemental")}</option>
                    <option value="fey">${game.i18n.localize("MI.referenseContent.creatureTypeList.fey")}</option>
                    <option value="fiend">${game.i18n.localize("MI.referenseContent.creatureTypeList.fiend")}</option>
                    <option value="giant">${game.i18n.localize("MI.referenseContent.creatureTypeList.giant")}</option>
                    <option value="humanoid">${game.i18n.localize("MI.referenseContent.creatureTypeList.humanoid")}</option>
                    <option value="monstrosity">${game.i18n.localize("MI.referenseContent.creatureTypeList.monstrosity")}</option>
                    <option value="ooze">${game.i18n.localize("MI.referenseContent.creatureTypeList.ooze")}</option>
                    <option value="plant">${game.i18n.localize("MI.referenseContent.creatureTypeList.plant")}</option>
                    <option value="undead">${game.i18n.localize("MI.referenseContent.creatureTypeList.undead")}</option>
                </select>
                </div>
                <div class="buttonCreatureTypeContainer"><button id="buttonCreatureType" class="buttonCreatureType button">${game.i18n.localize("MI.referenseContent.creatureTypeList.setCreatureType")}</button></div>
            </div>
            </div>
            <div class="tab" data-tab="tab5" data-group="referense-tabs">
            <div class=typeDamageContainer>

                <div><label>${game.i18n.localize("MI.referenseContent.typeDamageList.healing")}</label></div>
                <div><input id="healing" name="healing" type="checkbox"></div>
                      
                <div class="averageContainer">
                    <div><label>${game.i18n.localize("MI.referenseContent.average")}</label></div>
                    <div><input id="average" type="checkbox"></div>
                    <div><input id="numberAverage" type="number"></div>
                </div>

                <div><label for="typeDamage">${game.i18n.localize("MI.referenseContent.typeDamage")}:</label></div>
                <div>
                <select id="typeDamage" name="typeDamage">
                    <option value="">${game.i18n.localize("MI.referenseContent.typeDamageList.noType")}</option>
                    <option value="acid">${game.i18n.localize("MI.referenseContent.typeDamageList.acid")}</option>
                    <option value="bludgeoning">${game.i18n.localize("MI.referenseContent.typeDamageList.bludgeoning")}</option>
                    <option value="cold">${game.i18n.localize("MI.referenseContent.typeDamageList.cold")}</option>
                    <option value="fire">${game.i18n.localize("MI.referenseContent.typeDamageList.fire")}</option>
                    <option value="force">${game.i18n.localize("MI.referenseContent.typeDamageList.force")}</option>
                    <option value="lightning">${game.i18n.localize("MI.referenseContent.typeDamageList.lightning")}</option>
                    <option value="necrotic">${game.i18n.localize("MI.referenseContent.typeDamageList.necrotic")}</option>
                    <option value="piercing">${game.i18n.localize("MI.referenseContent.typeDamageList.piercing")}</option>
                    <option value="poison">${game.i18n.localize("MI.referenseContent.typeDamageList.poison")}</option>
                    <option value="psychic">${game.i18n.localize("MI.referenseContent.typeDamageList.psychic")}</option>
                    <option value="radiant">${game.i18n.localize("MI.referenseContent.typeDamageList.radiant")}</option>
                    <option value="slashing">${game.i18n.localize("MI.referenseContent.typeDamageList.slashing")}</option>
                    <option value="thunder">${game.i18n.localize("MI.referenseContent.typeDamageList.thunder")}</option>
                </select>
                </div>
                <div class="buttonTypeDamageContainer"><button id="buttonTypeDamage" class="buttonTypeDamage button">${game.i18n.localize("MI.referenseContent.typeDamageList.setDamageType")}</button></div>
            </div>
            </div>

            <div class="tab" data-tab="tab6" data-group="referense-tabs">
            <div class=ToolsContainer>
                <div>
                <select id="Tool" name="Tool">
                    <option value="alchemist">${game.i18n.localize("MI.referenseContent.toolsList.alchemist")}</option>
                    <option value="bagpipes">${game.i18n.localize("MI.referenseContent.toolsList.bagpipes")}</option>
                    <option value="brewer">${game.i18n.localize("MI.referenseContent.toolsList.brewer")}</option>
                    <option value="calligrapher">${game.i18n.localize("MI.referenseContent.toolsList.calligrapher")}</option>
                    <option value="card">${game.i18n.localize("MI.referenseContent.toolsList.card")}</option>
                    <option value="carpenter">${game.i18n.localize("MI.referenseContent.toolsList.carpenter")}</option>
                    <option value="cartographer">${game.i18n.localize("MI.referenseContent.toolsList.cartographer")}</option>
                    <option value="chess">${game.i18n.localize("MI.referenseContent.toolsList.chess")}</option>
                    <option value="cobbler">${game.i18n.localize("MI.referenseContent.toolsList.cobbler")}</option>
                    <option value="cook">${game.i18n.localize("MI.referenseContent.toolsList.cook")}</option>
                    <option value="dice">${game.i18n.localize("MI.referenseContent.toolsList.dice")}</option>
                    <option value="disg">${game.i18n.localize("MI.referenseContent.toolsList.disg")}</option>
                    <option value="dulcimer">${game.i18n.localize("MI.referenseContent.toolsList.dulcimer")}</option>
                    <option value="flute">${game.i18n.localize("MI.referenseContent.toolsList.flute")}</option>
                    <option value="forg">${game.i18n.localize("MI.referenseContent.toolsList.forg")}</option>
                    <option value="glassblower">${game.i18n.localize("MI.referenseContent.toolsList.glassblower")}</option>
                    <option value="herb">${game.i18n.localize("MI.referenseContent.toolsList.herb")}</option>
                    <option value="horn">${game.i18n.localize("MI.referenseContent.toolsList.horn")}</option>
                    <option value="leatherworker">${game.i18n.localize("MI.referenseContent.toolsList.leatherworker")}</option>
                    <option value="lute">${game.i18n.localize("MI.referenseContent.toolsList.lute")}</option>
                    <option value="lyre">${game.i18n.localize("MI.referenseContent.toolsList.lyre")}</option>
                    <option value="mason">${game.i18n.localize("MI.referenseContent.toolsList.mason")}</option>
                    <option value="navg">${game.i18n.localize("MI.referenseContent.toolsList.navg")}</option>
                    <option value="painter">${game.i18n.localize("MI.referenseContent.toolsList.painter")}</option>
                    <option value="panflute">${game.i18n.localize("MI.referenseContent.toolsList.panflute")}</option>
                    <option value="pois">${game.i18n.localize("MI.referenseContent.toolsList.pois")}</option>
                    <option value="potter">${game.i18n.localize("MI.referenseContent.toolsList.potter")}</option>
                    <option value="shawm">${game.i18n.localize("MI.referenseContent.toolsList.shawm")}</option>
                    <option value="smith">${game.i18n.localize("MI.referenseContent.toolsList.smith")}</option>
                    <option value="thief">${game.i18n.localize("MI.referenseContent.toolsList.thief")}</option>
                    <option value="tinker">${game.i18n.localize("MI.referenseContent.toolsList.tinker")}</option>
                    <option value="viol">${game.i18n.localize("MI.referenseContent.toolsList.viol")}</option>
                    <option value="weaver">${game.i18n.localize("MI.referenseContent.toolsList.weaver")}</option>
                    <option value="woodcarver">${game.i18n.localize("MI.referenseContent.toolsList.woodcarver")}</option>
                </select>
                </div>
                <div>
                <select id="abilityTool" name="abilitTooly">
                    <option value="strength">${game.i18n.localize("MI.referenseContent.abilityList.strength")}</option>
                    <option value="dexterity">${game.i18n.localize("MI.referenseContent.abilityList.dexterity")}</option>
                    <option value="constitution">${game.i18n.localize("MI.referenseContent.abilityList.constitution")}</option>
                    <option value="intelligence">${game.i18n.localize("MI.referenseContent.abilityList.intelligence")}</option>
                    <option value="wisdom">${game.i18n.localize("MI.referenseContent.abilityList.wisdom")}</option>
                    <option value="charisma">${game.i18n.localize("MI.referenseContent.abilityList.charisma")}</option>
                </select>
                </div>
                <div class="buttonToolContainer"><button id="buttonTool" class="buttonTool button">${game.i18n.localize("MI.referenseContent.toolsList.setTool")}</button></div>
            </div>
            </div>

            <div class="tab" data-tab="tab7" data-group="referense-tabs">
            <div class=areaOfEffectContainer>
                <div><label for="areaOfEffect">${game.i18n.localize("MI.referenseContent.areaOfEffect")}:</label></div>
                <div>
                <select id="areaOfEffect" name="areaOfEffect">
                    <option value="cone">${game.i18n.localize("MI.referenseContent.areaOfEffectList.cone")}</option>
                    <option value="cube">${game.i18n.localize("MI.referenseContent.areaOfEffectList.cube")}</option>
                    <option value="sphere">${game.i18n.localize("MI.referenseContent.areaOfEffectList.sphere")}</option>
                    <option value="square">${game.i18n.localize("MI.referenseContent.areaOfEffectList.square")}</option>
                    <option value="line">${game.i18n.localize("MI.referenseContent.areaOfEffectList.line")}</option>
                </select>
                </div>
                <div class="buttonAreaOfEffectContainer"><button id="buttonAreaOfEffect" class="buttonAreaOfEffect button">${game.i18n.localize("MI.referenseContent.areaOfEffectList.setAreaOfEffect")}</button></div>
            </div>
            </div>
            <div class="tab" data-tab="tab8" data-group="referense-tabs">
            <div class=componentContainer>
                <div><label for="component">${game.i18n.localize("MI.referenseContent.component")}:</label></div>
                <div>
                <select id="component" name="component">
                    <option value="concentration">${game.i18n.localize("MI.referenseContent.componentList.concentration")}</option>
                    <option value="material">${game.i18n.localize("MI.referenseContent.componentList.material")}</option>
                    <option value="ritual">${game.i18n.localize("MI.referenseContent.componentList.ritual")}</option>
                    <option value="somatic">${game.i18n.localize("MI.referenseContent.componentList.somatic")}</option>
                    <option value="verbal">${game.i18n.localize("MI.referenseContent.componentList.verbal")}</option>
                </select>
                </div>
                <div class="buttonComponentContainer"><button id="buttonComponent" class="buttonComponent button">${game.i18n.localize("MI.referenseContent.componentList.setComponent")}</button></div>
            </div>
                </div>
            <div class="tab" data-tab="tab9" data-group="referense-tabs">
            <div class=spellSchoolContainer>
                <div><label for="spellSchool">${game.i18n.localize("MI.referenseContent.spellSchool")}:</label></div>
                <div>
                <select id="spellSchool" name="spellSchool">
                    <option value="abjuration">${game.i18n.localize("MI.referenseContent.spellSchoolList.abjuration")}</option>
                    <option value="conjuration">${game.i18n.localize("MI.referenseContent.spellSchoolList.conjuration")}</option>
                    <option value="divination">${game.i18n.localize("MI.referenseContent.spellSchoolList.divination")}</option>
                    <option value="enchantment">${game.i18n.localize("MI.referenseContent.spellSchoolList.enchantment")}</option>
                    <option value="evocation">${game.i18n.localize("MI.referenseContent.spellSchoolList.evocation")}</option>
                    <option value="illusion">${game.i18n.localize("MI.referenseContent.spellSchoolList.illusion")}</option>
                    <option value="necromancy">${game.i18n.localize("MI.referenseContent.spellSchoolList.necromancy")}</option>
                    <option value="transmutation">${game.i18n.localize("MI.referenseContent.spellSchoolList.transmutation")}</option>
                </select>
                </div>
                <div class="buttonSpellSchoolContainer"><button id="buttonSpellSchool" class="buttonSpellSchool button">${game.i18n.localize("MI.referenseContent.spellSchoolList.setSpellSchool")}</button></div>
            </div>
            </div>
        </section>
    </div>
    `

    awardsContent = `
        <div class="awardsContainer">
            <div class="form-group">
                <div><label for="pp">${game.i18n.localize("MI.awordsContent.pp")}:</label></div>
                <div><input type="number" id="pp" name="pp" value=""></div>
                <div><img src="systems/dnd5e/icons/currency/platinum.webp" name="ppImg" ></div>
            </div>
            <div class="form-group">
                <div><label for="gp">${game.i18n.localize("MI.awordsContent.gp")}:</label></div>
                <div><input type="number" id="gp" name="gp" value=""></div>
                <div><img src="systems/dnd5e/icons/currency/gold.webp" name="ppImg"></div>
            </div>
            <div class="form-group">
                <div><label for="ep">${game.i18n.localize("MI.awordsContent.ep")}:</label></div>
                <div><input type="number" id="ep" name="ep" value=""></div>
                <div><img src="systems/dnd5e/icons/currency/electrum.webp" name="ppImg"></div>
            </div>
            <div class="form-group">
                <div><label for="sp">${game.i18n.localize("MI.awordsContent.sp")}:</label></div>
                <div><input type="number" id="sp" name="sp" value=""></div>
                <div><img src="systems/dnd5e/icons/currency/silver.webp" name="ppImg"></div>
            </div>
            <div class="form-group">
                <div><label for="cp">${game.i18n.localize("MI.awordsContent.cp")}:</label></div>
                <div><input type="number" id="cp" name="cp" value=""></div>
                <div><img src="systems/dnd5e/icons/currency/copper.webp" name="ppImg"></div>
            </div>
            <div class="form-group">
                <div><label for="xp">${game.i18n.localize("MI.awordsContent.xp")}:</label></div>
                <div><input type="number" id="xp" name="xp" value=""></div>
                <div><img src="systems/dnd5e/ui/inspiration.webp" name="ppImg"></div>
            </div>
            <div class="buttonClearContainer"><button id="buttonClear" class="buttonClear button">${game.i18n.localize("MI.awordsContent.clear")}</button></div>
            <div class="buttonAwordsContainer"><button id="buttonAwords" class="buttonAwords button">${game.i18n.localize("MI.awordsContent.setAward")}</button></div>
        </div>
            `
    colorContent = `
            <div class="ColorContent">
                <div class="ColorContentRow">
                    <div><label for="colour">${game.i18n.localize("MI.colorContent.color")}:</label></div>
                    <div><input type="color" id="colour" name="color" value="#ffffff"></div>
                </div>
                <div><input type="text" id="colorHex" name="colorHex" value="#ffffff"></div>
                <div class="ColorContentRow">
                    <div><input id="nameColor" type="text"></div>
                    <div data="button"><button id="buttonColorAdd" class="buttonColorAdd button">${game.i18n.localize("MI.colorContent.save")}</button></div>
                </div>
                <div class="ColorContentRow">
                    <div data="button"><button id="buttonColor" class="buttonColor button">${game.i18n.localize("MI.colorContent.setColourText")}</button></div>
                    <div data="button"><button id="buttonColorBackground" class="buttonColorBackground button">${game.i18n.localize("MI.colorContent.setColourBorder")}</button></div>
                </div>
                <div class="ColorContentRow">
                    <div>
                        <select id="userPalette" name="userPalette">
                        </select>
                    </div>
                    <div data="button"><button id="buttonDeleteColor" class="buttonDeleteColor button">${game.i18n.localize("MI.colorContent.deleteColor")}</button></div>
                </div>
            </div>
    `

    static get defaultOptions() {
        return foundry.utils.mergeObject(super.defaultOptions, {
            object: {},
            template: "./modules/Arcane-Ink/templates/book.hbs",
            popOut: true,
            resizable: true,
            title: game.i18n.localize("MI.name"),
            tabs: [
                {navSelector: ".tabs", contentSelector: ".content", initial: "tab1"}, 
                {navSelector: ".referenseTabs", contentSelector: ".contentRef", initial: "tab1"}
            ]
        });
    }

    getSelectedText(){
        let selectedText = document.getSelection().getRangeAt(0).cloneContents();
        const serializer = new XMLSerializer();
        selectedText = serializer.serializeToString(selectedText);
        selectedText = selectedText.replaceAll('xmlns="http://www.w3.org/1999/xhtml"', "");
        return selectedText
    }

    async pathPicker(inputForm, img, butImg){
        let path = new FilePicker();
        dataBook.filePath = inputForm;
        dataBook.fileImg = img;
        dataBook.buttonImg = butImg;
        path.callback = this.make_path;
        path.render();
    }

    async make_path(args){
        game.user.setFlag(moduleName, "picturePath", args);
        dataBook.filePath[0].value = args;
        dataBook.fileImg[0].src = args;
        dataBook.buttonImg[0].src = args;
    }

    getData(app, html) {
        const data = super.getData();

        data.footer = `${game.i18n.localize("MI.footer")}<a href="${game.i18n.localize("MI.boostSite")}">${game.i18n.localize("MI.boostSite")}</a>`;

        data.tabs = [{ 
            id: "tab1",
            label: "tab1",
            title: game.i18n.localize("MI.mainTabs.pictureAndDesign"),
            content: this.picturesContent
        },
        { 
            id: "tab2",
            label: "tab2",
            title: game.i18n.localize("MI.mainTabs.reference"),
            content: this.referenseContentTabs
        },
        { 
            id: "tab3",
            label: "tab3",
            title: game.i18n.localize("MI.mainTabs.award"),
            content: this.awardsContent
        },
        { 
            id: "tab4",
            label: "tab4",
            title: game.i18n.localize("MI.mainTabs.color"),
            content: this.colorContent
        },
    ];
        return data;
    }

    async formLoading(html){
        dataBook.colorHex = html.find('[id="colorHex"]');
        dataBook.colorViget = html.find('[id="colour"]');
        dataBook.select = html.find('[id="userPalette"]');
        dataBook.filePath = html.find('[name="picturesInput"]');
        dataBook.fileImg = html.find('[name="refImg"]');
        dataBook.buttonImg = html.find('[id="butImg"]');
        dataBook.filePath[0].value = (game.user.getFlag(moduleName, "picturePath") !== undefined) ? game.user.getFlag(moduleName, "picturePath") : "icons/vtt-512.png";
        dataBook.fileImg[0].src = dataBook.filePath[0].value;
        dataBook.buttonImg[0].src = dataBook.filePath[0].value;
        dataBook.userColors = game.user.getFlag(moduleName, "userColors") ? game.user.getFlag(moduleName, "userColors"): {};
        if (game.user.getFlag(moduleName, "rounded")){
            let round = html.find('[name="onCircle"]');
            await round.prop( "checked", true);
            await round.trigger('change');
        }
        dataBook.select.find('option').remove();
        for (const [_color, _name] of Object.entries(dataBook.userColors)) {
            await dataBook.select.append(`<option style="background-color: ${_color};" value=${_color} >${_name}</option>`);
        }
        await dataBook.select.trigger('change');
    }
    activateListeners(html) {
        this.formLoading(html);

        html.on('click', '#refImg', () => {
            this.pathPicker(html.find('[name="picturesInput"]'), html.find('[name="refImg"]'), html.find('[id="butImg"]'));
        })

        html.on('change', '#picturesInput', () => {
            this.make_path(html.find('[name="picturesInput"]').value);
        })  

        html.on('click', '#addPictures', () => {
            let scale = html.find('[name="scale"]')[0].value;
            let direction = '';
            let circle = '';
            if (html.find('[name="leftCheck"]')[0].checked) {
                direction = 'left';
            }
            if (html.find('[name="onCircle"]')[0].checked) {
                circle = 'class="round"';
            }
            if (html.find('[name="rightCheck"]')[0].checked) {
                direction = 'right';
            }
            let icon = html.find('[name="picturesInput"]')[0].value;
            let selectedText = document.getSelection().toString();
            let newContent = `<figure class="${direction} ${scale}"><img src=${icon} ${circle}><figcaption><p>${selectedText}</p></figcaption></figure>`;
            document.execCommand('insertHTML', false, newContent);
          })

        html.on('click', '#buttonAbility', () => {
            let pattern = new RegExp('[\\d]{1,2}[d,D,к,К][\\d]{1,3}');
            let num = new RegExp('\\d{1,3}');
            let selectedText = document.getSelection().toString();
            let check = "/check";
            let passive = '';
            let result;
            if (html.find('[id="skillPassiveCheck"]')[0].checked){
                passive = 'passive';
            }
            let modify = html.find('[id="numberForMod"]')[0].value | 0;
            let ability = html.find('[name="ability"]')[0].value;
            if (html.find('[name="abilityCheck"]')[0].checked) {
                check = '/save';
            }
            if (html.find('[id="numberCheck"]')[0].checked){
                result = selectedText.match(num);
                if (result){
                    modify = result[0];
                }
            }
            let newContent = `[[${check} ${passive} ${ability} ${modify}]]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `[[${check} ${passive} ${ability} ${modify}]]`;
            }
            document.execCommand('insertHTML', false, newContent);
          })

        html.on('click', '#buttonSkill', () => {
            let pattern = new RegExp('[\\d]{1,2}[d,D,к,К][\\d]{1,3}');
            let num = new RegExp('\\d{1,3}');
            let selectedText = document.getSelection().toString();
            let passive = '';
            let result;
            if (html.find('[id="skillPassiveCheck"]')[0].checked){
                passive = 'passive';
            }
            let modify = html.find('[id="numberForMod"]')[0].value | 0;
            let skill = html.find('[name="skill"]')[0].value;
            if (html.find('[id="numberCheck"]')[0].checked){
                result = selectedText.match(num);
                if (result){
                    modify = result[0];
                }
            }
            let newContent = `[[/skill ${passive} ${skill} ${modify}]]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `[[/skill ${passive} ${skill} ${modify}]]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonTypeDamage', () => {  //////22222222222222222222222222
            let pattern = new RegExp('[\\d]{1,2}[d,D,к,К,k,K,д,Д][\\d]{1,3}');
            let d = new RegExp('[D,к,К,k,K,д,Д]');
            let selectedText = document.getSelection().toString();
            let average = '';
            let damage = '/damage'
            let result;
            if (selectedText){
                result = selectedText.match(pattern)[0];
                result = result.replace(d, 'd')
            }
            if (html.find('[id="average"]')[0].checked) {
                average = html.find('[id="numberAverage"]')[0].value | 'true';
                average = `average=${average}`;
            }
            let damageFormula = html.find('[id="damageFormula"]')[0].value;
            damageFormula = damageFormula.replace(d, 'd')
            let typeDamage = html.find('[name="typeDamage"]')[0].value;
            if (html.find('[id="numberCheck"]')[0].checked){
                if (result){
                    damageFormula = result
                }
            }
            if (html.find('[id="healing"]')[0].checked) {
                damage = '/healing';
                typeDamage ='';
            }
            let newContent = `[[${damage} ${damageFormula} ${typeDamage} ${average}]]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `[[${damage} ${damageFormula} ${typeDamage} ${average}]]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonTool', () => {
            let num = new RegExp('\\d{1,3}');
            let selectedText = document.getSelection().toString();
            let passive = '';
            let average = '';
            let result;
            if (html.find('[id="average"]')[0].checked) {
                average = 'average'
            }
            if (html.find('[id="skillPassiveCheck"]')[0].checked){
                passive = 'passive';
            }
            let modify = html.find('[id="numberForMod"]')[0].value | 0;
            let tool = html.find('[name="Tool"]')[0].value;
            let ability = html.find('[name="abilitTooly"]')[0].value;
            if (html.find('[id="numberCheck"]')[0].checked){
                result = selectedText.match(num);
                if (result){
                    modify = result[0]
                }
            }
            let newContent = `[[/tool ${passive} ${tool} ${ability} ${modify}]]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `[[/tool ${passive} ${tool} ${ability} ${modify}]]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonCondition', () => {
            let selectedText = document.getSelection().toString();
            let condition = html.find('[name="condition"]')[0].value;
            let newContent = `&Reference[${condition}]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `&Reference[${condition}]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonCreatureType', () => {
            let selectedText = document.getSelection().toString();
            let creatureType = html.find('[name="creatureType"]')[0].value;
            let newContent = `&Reference[${creatureType}]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `&Reference[${creatureType}]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonAreaOfEffect', () => {
            let selectedText = document.getSelection().toString();
            let areaOfEffect = html.find('[name="areaOfEffect"]')[0].value;
            let newContent = `&Reference[${areaOfEffect}]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `&Reference[${areaOfEffect}]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonComponent', () => {
            let selectedText = document.getSelection().toString();
            let component = html.find('[name="component"]')[0].value;
            let newContent = `&Reference[${component}]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `&Reference[${component}]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonSpellSchool', () => {
            let selectedText = document.getSelection().toString();
            let spellSchool = html.find('[name="spellSchool"]')[0].value;
            let newContent = `&Reference[${spellSchool}]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `&Reference[${spellSchool}]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonAwords', () => {
            let pp = html.find('[id="pp"]')[0].value;
            let gp = html.find('[id="gp"]')[0].value;
            let ep = html.find('[id="ep"]')[0].value;
            let sp = html.find('[id="sp"]')[0].value;
            let cp = html.find('[id="cp"]')[0].value;
            let xp = html.find('[id="xp"]')[0].value;
            if (pp){pp = `${pp}pp`;}
            if (gp){gp = `${gp}gp`;}
            if (ep){ep = `${ep}ep`;}
            if (sp){sp = `${sp}sp`;}
            if (cp){cp = `${cp}cp`;}
            if (xp){xp = `${xp}xp`;}
            let result = `${pp} ${gp} ${ep} ${sp} ${cp} ${xp}`
            if (result != '     '){
                let newContent = `[[/award ${result}]]`;
                document.execCommand('insertHTML', false, newContent);
            }
        })

        html.on('click', '#buttonClear', () => {
            html.find('[id="pp"]')[0].value = '';
            html.find('[id="gp"]')[0].value = '';
            html.find('[id="ep"]')[0].value = '';
            html.find('[id="sp"]')[0].value = '';
            html.find('[id="cp"]')[0].value = '';
            html.find('[id="xp"]')[0].value = '';
        })

        html.on('click', '#narrative', () => {
            let selectedText = this.getSelectedText();
            let newContent = `
            <section class="fvtt-relative">
                <section class="fvtt narrative">
                    <p>${selectedText}</p>
                </section>
            </section>
            `;
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#advice', () => {
            let selectedText = this.getSelectedText();
            let circle = '';
            if (html.find('[name="onCircle"]')[0].checked) {
                circle = 'class="round"';
            }
            let icon = html.find('[name="picturesInput"]')[0].value;
            let newContent = `
            <div>
            <section class="fvtt advice">
                <figure class="icon">
                    <img src=${icon} ${circle}>
                </figure>
                <article>
                    ${selectedText}</p>
                </article>
            </section>
            </div>
            `;
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#notable', () => {
            let selectedText = this.getSelectedText();
            let newContent = `
            <aside class="notable">
                <p>${selectedText}</p>
            </aside>

            `;
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonColorAdd', async () => {
            await game.user.setFlag(moduleName, "userColors", null);
            let color = dataBook.colorViget[0].value;
            let name = html.find('[id="nameColor"]')[0].value;
            dataBook.userColors[color] = name;
            await dataBook.select.find('option').remove();
            await game.user.setFlag(moduleName, "userColors", dataBook.userColors);
            for (const [_color, _name] of Object.entries(dataBook.userColors)) {
                await dataBook.select.append(`<option style="background-color: ${_color};" value=${_color} >${_name}</option>`);
            }
            dataBook.select.val(color).selected = true;
            await dataBook.select.trigger('change');
        })

        html.on('click', '#buttonColor', async () => {
            let color = dataBook.colorViget[0].value;
            let selectedText = document.getSelection().toString();
            let newContent = `<span style="color:${color};">${selectedText}</span>`;
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonColorBackground', async () => {
            let color = dataBook.colorViget[0].value;
            let selectedText = this.getSelectedText();
            let newContent = `<div style="padding:0px 5px;background-color:${color};border:1px outset black;box-shadow:2px 2px 2px;border-radius:5px">${selectedText}</div>`;
            document.execCommand('insertHTML', false, newContent);
         
        })

        html.on('click', '#buttonDeleteColor', async () => {
            await game.user.setFlag(moduleName, "userColors", null);
            await delete dataBook.userColors[dataBook.select[0].value];
            await dataBook.select.find('option').remove();
            await game.user.setFlag(moduleName, "userColors", dataBook.userColors);
            for (const [_color, _name] of Object.entries(dataBook.userColors)) {
                await dataBook.select.append(`<option style="background-color: ${_color};" value=${_color} >${_name}</option>`);
            }
            dataBook.select.trigger('change');
        })

        html.find('.itemRef').click((e) => {
            const clickedTabId = e.currentTarget.dataset.tab;
            if (clickedTabId == "tab1" | clickedTabId == "tab2" | clickedTabId == "tab6"){
                html.find('.numberCheck').show();
                html.find('.skillPassiveCheck').show();
                html.find('.numberForMod').show();
            }
            else{
                html.find('.numberCheck').hide();
                html.find('.skillPassiveCheck').hide();
                html.find('.numberForMod').hide();
            }
            if (clickedTabId == "tab5"){
                html.find('.damageFormula').show();
                html.find('.numberCheck').show();
            }
            else{
                html.find('.damageFormula').hide();
            }
        });
        
        html.on('change', '#colour', (event) => {
            dataBook.colorHex[0].value = dataBook.colorViget[0].value;
        })
        
        html.on('change', '#colorHex', (event) => {
            let color = dataBook.colorHex[0].value
            if (color.startsWith('#')){
                dataBook.colorViget[0].value = dataBook.colorHex[0].value;
        }
        })

        html.on('change', '#numberCheck', (event) => {
            if (event.currentTarget.checked) {
                html.find('[id="numberForMod"]').prop( "disabled", true);
                html.find('[id="damageFormula"]').prop( "disabled", true);
              } else {
                html.find('[id="numberForMod"]').prop( "disabled", false);
                html.find('[id="damageFormula"]').prop( "disabled", false);
              }
        })

        html.on('change', '#healing', (event) => {
            if (event.currentTarget.checked) {
                html.find('[name="typeDamage"]').prop( "disabled", true);
              } else {
                html.find('[name="typeDamage"]').prop( "disabled", false);
              }
        })

        html.on('change', '#onCircle', (event) => {
            if (event.currentTarget.checked) {
                dataBook.fileImg.addClass(['round']);
                dataBook.buttonImg.addClass(['round']);
                game.user.setFlag(moduleName, "rounded", true)
              } else {
                dataBook.fileImg.removeClass(['round']);
                dataBook.buttonImg.removeClass(['round']);
                game.user.setFlag(moduleName, "rounded", false)
              }
        })

        html.on('change', '#userPalette', (event) => {
            dataBook.colorViget[0].value = dataBook.select[0].value;
            dataBook.select.css("background", dataBook.select[0].value);
        })

        html.on('change', '#leftCheck', (event) => {
            if (event.currentTarget.checked) {
                html.find('[name="rightCheck"]').prop( "checked", false );
              }
        })

        html.on('change', '#rightCheck', (event) => {
            if (event.currentTarget.checked) {
                html.find('[name="leftCheck"]').prop( "checked", false );
            }
        })
    }
    //class="round"

}

export class HtmlUtil {
    static book;
    static appendHeaderButton(html, title, fn) {
        let openBtn = $(`<a class="potion" title="${title}"><i class="fas fa-flask-round-potion"></i>${title}</a>`);
        openBtn.click(fn);
        html.closest('.app').find('.potion').remove();
        let titleElement = html.closest('.app').find('.window-title');
        openBtn.insertAfter(titleElement);
    }
}